clear all

*****   Lasso for prediction and model selection   *****

use cattaneo2

set seed 1907
splitsample, generate(sample) split(0.70 0.30)  
label define lbsample 1 "Training" 2 "Testing"  
label value sample lbsample
global covs (c.mage c.fage c.mage c.fage c.monthslb)##(c.mage ///
       c.fage c.mage c.fage c.monthslb) (mmarried mhisp fhisp ///
	   foreign alcohol msmoke fbaby prenatal1)##(c.mage c.fage /// 
	   c.medu c.fedu c.monthslb) 


quietly regress bweight $covs if sample == 1 
estimates store ols 
quietly lasso linear bweight $covs if sample == 1
estimates store lasso 
quietly elasticnet linear bweight $covs if sample == 1, alpha(0.2 0.5 0.75 0.9)
estimates store elastnet 
quietly sqrtlasso bweight $covs if sample == 1 
estimates store sqlasso

lassogof ols lasso elastnet sqlasso, over(sample)	   
		
preserve
quietly elasticnet linear bweight $covs, alpha(0.2 0.5 0.75 0.9)
estimates store elastnetfull 
use cattaneo2_new, clear 
estimates restore elastnetfull 
predict yhat_pen
predict yhat_postsel, postselection

restore
estimates restore lasso
lasso

coefpath, name(g1)

cvplot, name(g2)

lassoknots

quietly lasso linear bweight $covs 
estimates store cv  
quietly lasso linear bweight $covs, selection(adaptive) 
estimates store adaptive  
quietly lasso linear bweight $covs, selection(plugin) 
estimates store plugin
quietly lasso linear bweight $covs, selection(bic) 
estimates store bic

lassoinfo cv adaptive plugin bic

bicplot, name(g3)

lassocoef cv adaptive plugin bic, display(coef, standardized)



*********    Lasso for inference     ***********

use nlsy80,clear
global controls c.(meduc feduc sibs age iq kww)##(exper ///
       pcollege married black south urban)
dsregress wage educ tenure, controls($controls)
estimates store ds_plugin

poregress wage educ tenure, controls($controls)
xporegress wage educ tenure, controls($controls)
lassoinfo
dsregress wage educ tenure,controls($controls) ///
  lasso(wage,selection(adaptive)) ///
  lasso(educ,selection(bic)) ///
  sqrtlasso(tenure,selection(cv))
  
cvplot, for(tenure) name(g4) 

bicplot, for(educ) name(g5) 

quietly dsregress wage educ tenure, controls($controls) selection(cv)
estimates store ds_cv
quietly dsregress wage educ tenure, controls($controls) selection(adaptive)
estimates store ds_adapt
quietly dsregress wage educ tenure, controls($controls) selection(bic)
estimates store ds_bic
estimates table ds_plugin ds_cv ds_adapt ds_bic, b(%9.4f) se(%9.4f) p(%9.4f)    
